package de.uks.pmws112.hexentanz.gui;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.wb.swt.SWTResourceManager;

public class HexentanzMainScreen
{

   protected Shell shlHexentanz;

   private Label f8;

   private Label f18;

   private Label fhp1;

   private Label f11;

   private Label f31;

   private Label f20;

   private Label ffy2;

   private Label fhr4;

   private Label f2;

   private Label f14;

   private Label f16;

   private Label f30;

   private Label fhy2;

   private Label ffg3;

   private Label ffg2;

   private Label f24;

   private Label fhr2;

   private Label fhy1;

   private Label f12;

   private Label f10;

   private Label ffg4;

   private Label f22;

   private Label f26;

   private Label fhp2;

   private Label ffy1;

   private Label fhy4;

   private Label fhg2;

   private Label f27;

   private Label f23;

   private Label fhp3;

   private Label f1;

   private Label ffg1;

   private Label f19;

   private Label f4;

   private Label f13;

   private Label ffy4;

   private Label ffr3;

   private Label ffp4;

   private Label f28;

   private Label f5;

   private Label ffr4;

   private Label f29;

   private Label fhr1;

   private Label f17;

   private Label f21;

   private Label fhr3;

   private Label f15;

   private Label f9;

   private Label f25;

   private Label ffp2;

   private Label f6;

   private Label fhg3;

   private Label ffp3;

   private Label fhg1;

   private Label fhy3;

   private Label fhg4;

   private Label f7;

   private Label ffr2;

   private Label f3;

   private Label fhp4;

   private Label f32;

   private Label ffy3;

   private Label ffp1;

   private Label ffr1;
   private Label label;
   private Label playerNameLabel;
   private Label instructionLabel;
   private Label diceLabel;
   private Button btnRoll;
   private Label witchLabel;
   private Label playerColorLabel;

   /**
    * Open the window.
    */
   public void open()
   {
      shlHexentanz.open();
      shlHexentanz.layout();
      shlHexentanz.pack();
   }

//   private void initImages() throws Exception
//   {
//      Pattern fieldPattern = Pattern.compile("getF\\d{1,2}");
//      Pattern homePattern = Pattern.compile("getFh\\w\\d{1,2}");
//      Pattern finalPattern = Pattern.compile("getFf\\w\\d{1,2}");
//      
//      for(Method m : HexentanzMainScreen.class.getMethods())
//      {
//         String name = m.getName();
//         if(fieldPattern.matcher(name).matches())
//         {
//            // Normal field
//            Image normalField = SWTResourceManager.getImage(HexentanzMainScreen.class, "/img/fieldWhite.png");
//            ((Label)m.invoke(this)).setImage(normalField);
//         }
//         else if(homePattern.matcher(name).matches())
//         {
//            name = name.substring(3);
//            Image homeImg = null;
//            if(name.contains("r"))
//            {
//               homeImg = SWTResourceManager.getImage(HexentanzMainScreen.class, "/img/fieldRed.png");
//            }
//            else if(name.contains("g"))
//            {
//               homeImg = SWTResourceManager.getImage(HexentanzMainScreen.class, "/img/fieldGreen.png");
//            }
//            else if(name.contains("p"))
//            {
//               homeImg = SWTResourceManager.getImage(HexentanzMainScreen.class, "/img/fieldPurple.png");
//            }
//            else
//            {
//               homeImg = SWTResourceManager.getImage(HexentanzMainScreen.class, "/img/fieldYellow.png");
//            }
//            ((Label)m.invoke(this)).setImage(homeImg);
//         }
//         else if(finalPattern.matcher(name).matches())
//         {
//            name = name.substring(3);
//            Image finalImg = null;
//            if(name.contains("r"))
//            {
//               finalImg = SWTResourceManager.getImage(HexentanzMainScreen.class, "/img/fieldFinalRed.png");
//            }
//            else if(name.contains("g"))
//            {
//               finalImg = SWTResourceManager.getImage(HexentanzMainScreen.class, "/img/fieldFinalGreen.png");
//            }
//            else if(name.contains("p"))
//            {
//               finalImg = SWTResourceManager.getImage(HexentanzMainScreen.class, "/img/fieldFinalPurple.png");
//            }
//            else
//            {
//               finalImg = SWTResourceManager.getImage(HexentanzMainScreen.class, "/img/fieldFinalYellow.png");
//            }
//            ((Label)m.invoke(this)).setImage(finalImg);
//         }
//      }
//      
//      getF1().setImage(SWTResourceManager.getImage(HexentanzMainScreen.class, "/img/fieldPurpleLeft.png"));
//      getFsp().setImage(SWTResourceManager.getImage(HexentanzMainScreen.class, "/img/fieldPurpleRight.png"));
//      getF8().setImage(SWTResourceManager.getImage(HexentanzMainScreen.class, "/img/fieldRedRight.png"));
//      getF15().setImage(SWTResourceManager.getImage(HexentanzMainScreen.class, "/img/fieldGreenRight.png"));
//      getFsr().setImage(SWTResourceManager.getImage(HexentanzMainScreen.class, "/img/fieldRedDown.png"));
//      getF22().setImage(SWTResourceManager.getImage(HexentanzMainScreen.class, "/img/fieldYellowLeft.png"));
//      getFsg().setImage(SWTResourceManager.getImage(HexentanzMainScreen.class, "/img/fieldGreenLeft.png"));
//      getFsy().setImage(SWTResourceManager.getImage(HexentanzMainScreen.class, "/img/fieldYellowUp.png"));
//   }

   /**
    * Create contents of the window.
    * @wbp.parser.entryPoint
    */
   public void createContents()
   {
      shlHexentanz = new Shell();
      shlHexentanz.setSize(1131, 563);
      shlHexentanz.setText("Hexentanz");
      shlHexentanz.setLayout(new FillLayout(SWT.HORIZONTAL));

      Composite composite = new Composite(shlHexentanz, SWT.NONE);
      composite.setLayout(new GridLayout(3, false));

      Composite composite_1 = new Composite(composite, SWT.NONE);
      composite_1.setLayout(new GridLayout(14, false));
      composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);

      ffp2 = new Label(composite_1, SWT.NONE);
      ffp2.setText("New Label");

      ffp1 = new Label(composite_1, SWT.NONE);
      ffp1.setText("New Label");

      f1 = new Label(composite_1, SWT.NONE);
      f1.setText("New Label");

      f2 = new Label(composite_1, SWT.NONE);
      f2.setText("New Label");

      f3 = new Label(composite_1, SWT.NONE);
      f3.setText("New Label");

      f4 = new Label(composite_1, SWT.NONE);
      f4.setText("New Label");

      f5 = new Label(composite_1, SWT.NONE);
      f5.setText("New Label");

      f6 = new Label(composite_1, SWT.NONE);
      f6.setText("New Label");

      f7 = new Label(composite_1, SWT.NONE);
      f7.setText("New Label");

      f8 = new Label(composite_1, SWT.NONE);
      f8.setText("New Label");

      f9 = new Label(composite_1, SWT.NONE);
      f9.setText("New Label");

      ffr1 = new Label(composite_1, SWT.NONE);
      ffr1.setText("New Label");

      ffr2 = new Label(composite_1, SWT.NONE);
      ffr2.setText("New Label");
      new Label(composite_1, SWT.NONE);

      ffp3 = new Label(composite_1, SWT.NONE);
      ffp3.setText("New Label");
      new Label(composite_1, SWT.NONE);

      f32 = new Label(composite_1, SWT.NONE);
      f32.setText("New Label");
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);

      fhp1 = new Label(composite_1, SWT.NONE);
      fhp1.setText("New Label");

      fhp2 = new Label(composite_1, SWT.NONE);
      fhp2.setText("New Label");
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);

      f10 = new Label(composite_1, SWT.NONE);
      f10.setText("New Label");
      new Label(composite_1, SWT.NONE);

      ffr3 = new Label(composite_1, SWT.NONE);
      ffr3.setText("New Label");
      new Label(composite_1, SWT.NONE);

      ffp4 = new Label(composite_1, SWT.NONE);
      ffp4.setText("New Label");
      new Label(composite_1, SWT.NONE);

      f31 = new Label(composite_1, SWT.NONE);
      f31.setText("New Label");
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);

      fhp3 = new Label(composite_1, SWT.NONE);
      fhp3.setText("New Label");

      fhp4 = new Label(composite_1, SWT.NONE);
      fhp4.setText("New Label");
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);

      f11 = new Label(composite_1, SWT.NONE);
      f11.setText("New Label");
      new Label(composite_1, SWT.NONE);

      ffr4 = new Label(composite_1, SWT.NONE);
      ffr4.setText("New Label");
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);

      f30 = new Label(composite_1, SWT.NONE);
      f30.setText("New Label");

      fhy1 = new Label(composite_1, SWT.NONE);
      fhy1.setText("New Label");

      fhy2 = new Label(composite_1, SWT.NONE);
      fhy2.setText("New Label");
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);

      f12 = new Label(composite_1, SWT.NONE);
      f12.setText("New Label");
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);

      f29 = new Label(composite_1, SWT.NONE);
      f29.setText("New Label");

      fhy3 = new Label(composite_1, SWT.NONE);
      fhy3.setText("New Label");

      fhy4 = new Label(composite_1, SWT.NONE);
      fhy4.setText("New Label");
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);

      fhr1 = new Label(composite_1, SWT.NONE);
      fhr1.setText("New Label");

      fhr2 = new Label(composite_1, SWT.NONE);
      fhr2.setText("New Label");

      f13 = new Label(composite_1, SWT.NONE);
      f13.setText("New Label");
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);

      f28 = new Label(composite_1, SWT.NONE);
      f28.setText("New Label");
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);

      fhr3 = new Label(composite_1, SWT.NONE);
      fhr3.setText("New Label");

      fhr4 = new Label(composite_1, SWT.NONE);
      fhr4.setText("New Label");

      f14 = new Label(composite_1, SWT.NONE);
      f14.setText("New Label");
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);

      ffy4 = new Label(composite_1, SWT.NONE);
      ffy4.setText("New Label");
      new Label(composite_1, SWT.NONE);

      f27 = new Label(composite_1, SWT.NONE);
      f27.setText("New Label");
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);

      fhg1 = new Label(composite_1, SWT.NONE);
      fhg1.setText("New Label");

      fhg2 = new Label(composite_1, SWT.NONE);
      fhg2.setText("New Label");
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);

      f15 = new Label(composite_1, SWT.NONE);
      f15.setText("New Label");
      new Label(composite_1, SWT.NONE);

      ffg4 = new Label(composite_1, SWT.NONE);
      ffg4.setText("New Label");
      new Label(composite_1, SWT.NONE);

      ffy3 = new Label(composite_1, SWT.NONE);
      ffy3.setText("New Label");
      new Label(composite_1, SWT.NONE);

      f26 = new Label(composite_1, SWT.NONE);
      f26.setText("New Label");
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);

      fhg3 = new Label(composite_1, SWT.NONE);
      fhg3.setText("New Label");

      fhg4 = new Label(composite_1, SWT.NONE);
      fhg4.setText("New Label");
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);
      new Label(composite_1, SWT.NONE);

      f16 = new Label(composite_1, SWT.NONE);
      f16.setText("New Label");
      new Label(composite_1, SWT.NONE);

      ffg3 = new Label(composite_1, SWT.NONE);
      ffg3.setText("New Label");
      new Label(composite_1, SWT.NONE);

      ffy2 = new Label(composite_1, SWT.NONE);
      ffy2.setText("New Label");

      ffy1 = new Label(composite_1, SWT.NONE);
      ffy1.setText("New Label");

      f25 = new Label(composite_1, SWT.NONE);
      f25.setText("New Label");

      f24 = new Label(composite_1, SWT.NONE);
      f24.setText("New Label");

      f23 = new Label(composite_1, SWT.NONE);
      f23.setText("New Label");

      f22 = new Label(composite_1, SWT.NONE);
      f22.setText("New Label");

      f21 = new Label(composite_1, SWT.NONE);
      f21.setText("New Label");

      f20 = new Label(composite_1, SWT.NONE);
      f20.setText("New Label");

      f19 = new Label(composite_1, SWT.NONE);
      f19.setText("New Label");

      f18 = new Label(composite_1, SWT.NONE);
      f18.setText("New Label");

      f17 = new Label(composite_1, SWT.NONE);
      f17.setText("New Label");

      ffg1 = new Label(composite_1, SWT.NONE);
      ffg1.setText("New Label");

      ffg2 = new Label(composite_1, SWT.NONE);
      ffg2.setText("New Label");
      
      label = new Label(composite, SWT.SEPARATOR | SWT.VERTICAL);
      label.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false, false, 1, 1));

      Composite composite_2 = new Composite(composite, SWT.NONE);
      composite_2.setLayout(new GridLayout(2, false));
      composite_2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));

      Label lblCurrentPlayer = new Label(composite_2, SWT.NONE);
      lblCurrentPlayer.setFont(SWTResourceManager.getFont("Segoe UI", 16, SWT.NORMAL));
      lblCurrentPlayer.setText("Current Player:");

      playerNameLabel = new Label(composite_2, SWT.NONE);
      playerNameLabel.setFont(SWTResourceManager.getFont("Segoe UI", 16, SWT.NORMAL));
      playerNameLabel.setText("NoName");
      
      playerColorLabel = new Label(composite_2, SWT.NONE);
      playerColorLabel.setImage(SWTResourceManager.getImage(HexentanzMainScreen.class, "/img/fieldYellow.png"));
      playerColorLabel.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 2, 1));
      new Label(composite_2, SWT.NONE);
      new Label(composite_2, SWT.NONE);

      instructionLabel = new Label(composite_2, SWT.NONE);
      instructionLabel.setAlignment(SWT.CENTER);
      instructionLabel.setFont(SWTResourceManager.getFont("Segoe UI", 10, SWT.NORMAL));
      instructionLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 2, 1));
      instructionLabel.setText("No instruction...");
      new Label(composite_2, SWT.NONE);
      new Label(composite_2, SWT.NONE);
      new Label(composite_2, SWT.NONE);
      new Label(composite_2, SWT.NONE);
      new Label(composite_2, SWT.NONE);
      new Label(composite_2, SWT.NONE);

      Label lblDice = new Label(composite_2, SWT.NONE);
      lblDice.setFont(SWTResourceManager.getFont("Segoe UI", 16, SWT.NORMAL));
      lblDice.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 2, 1));
      lblDice.setText("Dice");

      diceLabel = new Label(composite_2, SWT.NONE);
      diceLabel.setImage(SWTResourceManager.getImage(HexentanzMainScreen.class, "/img/w3.png"));
      diceLabel.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 2, 1));

      btnRoll = new Button(composite_2, SWT.NONE);
      btnRoll.setFont(SWTResourceManager.getFont("Segoe UI", 9, SWT.BOLD));
      GridData gd_btnRoll = new GridData(SWT.CENTER, SWT.CENTER, false, false, 2, 1);
      gd_btnRoll.heightHint = 40;
      gd_btnRoll.widthHint = 70;
      btnRoll.setLayoutData(gd_btnRoll);
      btnRoll.setText("Roll");
      new Label(composite_2, SWT.NONE);
      new Label(composite_2, SWT.NONE);
      new Label(composite_2, SWT.NONE);
      new Label(composite_2, SWT.NONE);

      Label lblWitch = new Label(composite_2, SWT.NONE);
      lblWitch.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 2, 1));
      lblWitch.setFont(SWTResourceManager.getFont("Segoe UI", 16, SWT.NORMAL));
      lblWitch.setText("Witch");

      witchLabel = new Label(composite_2, SWT.BORDER);
      witchLabel.setImage(SWTResourceManager.getImage(HexentanzMainScreen.class, "/img/witchUnkown.png"));
      witchLabel.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 2, 1));
      new Label(composite_2, SWT.NONE);
      new Label(composite_2, SWT.NONE);

   }

   public Label getPlayerNameLabel() {
      return playerNameLabel;
   }
   public Label getInstructionLabel() {
      return instructionLabel;
   }
   public Label getDiceLabel() {
      return diceLabel;
   }
   public Button getRollButton() {
      return btnRoll;
   }
   public Label getWitchLabel() {
      return witchLabel;
   }
   public Shell getShell() {
      return shlHexentanz;
   }
   public Label getF23() {
      return f23;
   }
   public Label getFhr3() {
      return fhr3;
   }
   public Label getFfy4() {
      return ffy4;
   }
   public Label getFfr4() {
      return ffr4;
   }
   public Label getFfy1() {
      return ffy1;
   }
   public Label getF13() {
      return f13;
   }
   public Label getFfg2() {
      return ffg2;
   }
   public Label getFhr2() {
      return fhr2;
   }
   public Label getF19() {
      return f19;
   }
   public Label getF26() {
      return f26;
   }
   public Label getFfp3() {
      return ffp3;
   }
   public Label getFfy2() {
      return ffy2;
   }
   public Label getF12() {
      return f12;
   }
   public Label getF14() {
      return f14;
   }
   public Label getF31() {
      return f31;
   }
   public Label getF28() {
      return f28;
   }
   public Label getF2() {
      return f2;
   }
   public Label getFfg1() {
      return ffg1;
   }
   public Label getF1() {
      return f1;
   }
   public Label getFhp4() {
      return fhp4;
   }
   public Label getFhr4() {
      return fhr4;
   }
   public Label getFhp1() {
      return fhp1;
   }
   public Label getFhp2() {
      return fhp2;
   }
   public Label getF11() {
      return f11;
   }
   public Label getFfg3() {
      return ffg3;
   }
   public Label getFhg1() {
      return fhg1;
   }
   public Label getFfp4() {
      return ffp4;
   }
   public Label getF10() {
      return f10;
   }
   public Label getFfr1() {
      return ffr1;
   }
   public Label getF29() {
      return f29;
   }
   public Label getFhg3() {
      return fhg3;
   }
   public Label getF16() {
      return f16;
   }
   public Label getF27() {
      return f27;
   }
   public Label getF22() {
      return f22;
   }
   public Label getF6() {
      return f6;
   }
   public Label getFfg4() {
      return ffg4;
   }
   public Label getF25() {
      return f25;
   }
   public Label getFhg4() {
      return fhg4;
   }
   public Label getF24() {
      return f24;
   }
   public Label getF18() {
      return f18;
   }
   public Label getF17() {
      return f17;
   }
   public Label getFfr3() {
      return ffr3;
   }
   public Label getFhy2() {
      return fhy2;
   }
   public Label getF9() {
      return f9;
   }
   public Label getF15() {
      return f15;
   }
   public Label getFfp2() {
      return ffp2;
   }
   public Label getFfr2() {
      return ffr2;
   }
   public Label getF5() {
      return f5;
   }
   public Label getF8() {
      return f8;
   }
   public Label getFfy3() {
      return ffy3;
   }
   public Label getFhy1() {
      return fhy1;
   }
   public Label getF30() {
      return f30;
   }
   public Label getF7() {
      return f7;
   }
   public Label getFhy3() {
      return fhy3;
   }
   public Label getF32() {
      return f32;
   }
   public Label getF21() {
      return f21;
   }
   public Label getFfp1() {
      return ffp1;
   }
   public Label getFhy4() {
      return fhy4;
   }
   public Label getFhg2() {
      return fhg2;
   }
   public Label getFhp3() {
      return fhp3;
   }
   public Label getF3() {
      return f3;
   }
   public Label getF20() {
      return f20;
   }
   public Label getF4() {
      return f4;
   }
   public Label getFhr1() {
      return fhr1;
   }
   public Label getPlayerColorLabel() {
      return playerColorLabel;
   }
}
